//
// GALAXY IRC CLIENT DEMO APPLICATION VER. 2.6
// Anybody can use it as an idea or a skeleton
// for his own IRC clients/bots/games.
// (C) Digimaster Feb 2001 e-mail: digimaster@au.ru
//
unit demo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Menus, StdCtrls, contnrs, Ircomp5;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Ircmenu1: TMenuItem;
    About1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    AboutDemo1: TMenuItem;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    RichEdit1: TRichEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Irc1: TIrc;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AboutDemo1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Irc1Unknown(Sender: TObject; Msg: String);
    procedure Irc1Connect(Sender: TObject; Server: String);
    procedure Irc1Disconnect(Sender: TObject; Server: String);
    procedure Irc1Join(Sender: TObject; ForMe: Boolean; Room, Nick, User,
      Host: String);
    procedure Irc1NamesChange(Sender: TObject; Room: String);
    procedure Irc1Privmsg(Sender: TObject; ForMe: Boolean; Nick, User,
      Host, Dest, Msg: String);
    procedure Irc1Part(Sender: TObject; ForMe: Boolean; Room, Nick,
      PartMsg: String);
    procedure Irc1Quit(Sender: TObject; ForMe: Boolean; Nick,
      QuitMsg: String);
    procedure Irc1Nick(Sender: TObject; ForMe: Boolean; OldNick,
      NewNick: String);
    procedure Irc1Kick(Sender: TObject; ForMe: Boolean; KickerNick,
      KickedNick, Room, KickMsg: String);
    procedure Irc1Mode(Sender: TObject; ForMe: Boolean; Nick, Room,
      Mode: String);
    procedure Irc1Notice(Sender: TObject; ForMe: Boolean; Nick, User, Host,
      Dest, Msg: String);
    procedure Irc1Ping(Sender: TObject; Nick, User, Host, idstr: String);
    procedure Irc1Time(Sender: TObject; Nick, User, Host: String);
    procedure Irc1Topic(Sender: TObject; ForMe: Boolean; Nick, Room,
      Topic: String);
    procedure Irc1Irc(Sender: TObject; Server: String);
    procedure Irc1Version(Sender: TObject; Nick, User, Host: String);
    procedure Irc1Names(Sender: TObject; Room: String);
    procedure Irc1CTCP(Sender: TObject; Nick, User, Host, Cmd,
      Par: String);
    procedure Irc1DCC(Sender: TObject; Nick, User, Host, Cmd, Par: String);
    procedure Irc1ServerError(Sender: TObject; ErrMsg: String);
    procedure Irc1SocketError(Sender: TObject; ErrCode: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure NewRoomWnd(Room:string);
    procedure NewUserWnd(Nick:string);
    procedure WndButtonClick(Sender: TObject);
    procedure WndDelete(Sender:TObject; var Action: TCloseAction);
    procedure ReArrangeButtons;
    function IsRoomButton(Sender:TObject):boolean;
    function RoomIndex(Room:string):integer;
    function UserIndex(Nick:string):integer;
    procedure Addtext(msg:string);
  end;

const
  DemoVerMsg='GALAXY IRC COMPONENT USAGE DEMO Ver.2.6';

var
  Form1: TForm1;
  ChatWnd:TComponentList;
  UserWnd:TComponentList;
  BttnLst:TComponentList;

implementation

uses roomterm, userterm;

{$R *.DFM}

//Which channel window has a Room caption

function TForm1.RoomIndex(Room:string):integer;
var
 i:integer;
begin
 Result:=-1;
 for i:=0 to ChatWnd.Count-1 do
  if LowerCase((ChatWnd.Items[i] as TForm2).Caption)=LowerCase(Room) then begin
   Result:=i;
   break;
  end;
end;

//Which user private window has a Nick caption

function TForm1.UserIndex(Nick:string):integer;
var
 i:integer;
begin
 Result:=-1;
 for i:=0 to UserWnd.Count-1 do
  if LowerCase((UserWnd.Items[i] as TForm3).Caption)=LowerCase(Nick) then begin
   Result:=i;
   break;
  end;
end;

//Add message to the main terminal

procedure TForm1.Addtext(msg:string);
begin
 while RichEdit1.Lines.Count>1000 do RichEdit1.Lines.Delete(0);
 RichEdit1.Lines.Add(msg);
 with RichEdit1 do begin
  SelStart:=length(RichEdit1.Text);
  SendMessage(handle,EM_SCROLLCARET,SelStart,0);
 end;
end;

//Is Sender's Button corresponded to the channel window (true) or it is
//corresponded to the user private window (false)

function TForm1.IsRoomButton(Sender:TObject):boolean;
var
  i:integer;
begin
  Result:=false;
  for i:=0 to ChatWnd.Count-1 do begin
   if (Sender as TButton).Caption=(ChatWnd.Items[i] as TForm2).Caption then begin
    Result:=true;
    break;
   end;
  end;
end;

//Place Buttons on the panel

procedure TForm1.ReArrangeButtons;
var
 i:integer;
 btn:TButton;
begin
 // *************** ReArrange Panel Buttons *****************
 BttnLst.Clear;
 for i:=0 to ChatWnd.Count-1 do begin
  btn:=TButton.Create(nil);
  btn.tag:=i;
  btn.Left:=i*100;
  btn.Width:=98;
  btn.Caption:=(ChatWnd.items[i] as TForm2).Caption;
  btn.OnClick:=WndButtonClick;
  btn.Parent:=Panel3;
  BttnLst.Add(btn);
 end;
 for i:=0 to UserWnd.Count-1 do begin
  btn:=TButton.Create(nil);
  btn.tag:=i;
  btn.Left:=(ChatWnd.Count+i)*100;
  btn.Width:=98;
  btn.Caption:=(UserWnd.items[i] as TForm3).Caption;
  btn.OnClick:=WndButtonClick;
  btn.Parent:=Panel3;
  BttnLst.Add(btn);
 end;
end;

// Create new chat window when entering on IRC channel

procedure TForm1.NewRoomWnd(Room:string);
var
 frm:TForm2;
begin
 frm:=TForm2.Create(Self);
 frm.Caption:=Room;
 //frm.Name:=Room;
 frm.OnClose:=WndDelete;
 ChatWnd.Add(frm);
 (ChatWnd.Items[ChatWnd.IndexOf(frm)] as TForm2).Show;
 // *************** ReArrange Buttons *****************
 ReArrangeButtons;
end;

// Create new private chat window when private talking with user

procedure TForm1.NewUserWnd(Nick:string);
var
 frm:TForm3;
begin
 frm:=TForm3.Create(Self);
 frm.Caption:=Nick;
 //frm.Name:=Nick;
 frm.OnClose:=WndDelete;
 UserWnd.Add(frm);
 (UserWnd.Items[UserWnd.IndexOf(frm)] as TForm3).Show;
 // *************** ReArrange Buttons *****************
 ReArrangeButtons;
end;

// Delete chat window and send PART #channel when [X]CloseWindow clicked

procedure TForm1.WndDelete(Sender:TObject; var Action: TCloseAction);
begin
 Action:=caFree;
 if Sender.ClassType=TForm2 then begin
  Irc1.SendText('PART '+(Sender as TForm2).Caption);
  ChatWnd.Extract(Sender);
  ChatWnd.Pack;
 end else begin
  UserWnd.Extract(Sender);
  UserWnd.Pack;
 end;
 ReArrangeButtons;
end;

// Restore Chat Window on Button click

procedure TForm1.WndButtonClick(Sender: TObject);
begin
 if IsRoomButton(Sender) then begin
  (ChatWnd.Items[(Sender as TButton).tag] as TForm2).Show;
  (ChatWnd.Items[(Sender as TButton).tag] as TForm2).WindowState:=wsNormal;
 end else begin
  (UserWnd.Items[(Sender as TButton).tag] as TForm3).Show;
  (UserWnd.Items[(Sender as TButton).tag] as TForm3).WindowState:=wsNormal;
 end;
end;

//Application form create event

procedure TForm1.FormCreate(Sender: TObject);
begin
 ChatWnd:=TComponentList.Create;
 ChatWnd.OwnsObjects:=false;
 UserWnd:=TComponentList.Create;
 UserWnd.OwnsObjects:=false;
 BttnLst:=TComponentList.Create;
end;

//Application form destroy event

procedure TForm1.FormDestroy(Sender: TObject);
begin
 ChatWnd.OwnsObjects:=true;
 ChatWnd.Free;
 UserWnd.OwnsObjects:=true;
 UserWnd.Free;
 BttnLst.Free;
end;

//About this program

procedure TForm1.AboutDemo1Click(Sender: TObject);
begin
 ShowMessage(DemoVerMsg);
end;

//Connect to IRC now!

procedure TForm1.Connect1Click(Sender: TObject);
begin
 Irc1.IrcServer:=Edit2.Text;
 try
  Irc1.Connect;
 except
  AddText('Cannot connect to server '+Irc1.IrcServer);
 end;
end;

//Disconnect from IRC now

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
 Irc1.Disconnect;
end;

//Exit this program

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

//Send message to IRC

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var
 s:string;
begin
 if Key=chr(13) then begin
  s:=Edit1.Text;
  AddText(s);
  Edit1.Text:='';
  if s[1]='/' then Irc1.SendText(Copy(s,2,Length(s)-1))
  else Irc1.SendText(s);
 end;
end;

//
// ****************************** IRC EVENTS ***********************************
//

procedure TForm1.Irc1Unknown(Sender: TObject; Msg: String);
begin
 //All Unassigned IRC events will be passed here
 AddText(Msg);
end;

procedure TForm1.Irc1Connect(Sender: TObject; Server: String);
begin
 //IRC server connection accepted but not granted
 Statusbar1.SimpleText:=Server+' ONLINE';
end;

procedure TForm1.Irc1Disconnect(Sender: TObject; Server: String);
begin
 //IRC server connection broked
 Statusbar1.SimpleText:=Server+' offline';
end;

procedure TForm1.Irc1Join(Sender: TObject; ForMe: Boolean; Room, Nick,
  User, Host: String);
begin
 //Somebody Join <Room> channel
 if ForMe then NewRoomWnd(Room);
 (ChatWnd.Items[RoomIndex(Room)] as TForm2).AddText(Nick+' JOIN '+Room);
end;

procedure TForm1.Irc1NamesChange(Sender: TObject; Room: String);
begin
 // Updating corresponded ListBox when somebody JOIN/PART/QUIT/NICKCHANGE/KICK..
 if (RoomIndex(Room)>-1) and (Irc1.irc.Ind(Room)>-1) then begin
  (ChatWnd.Items[RoomIndex(Room)] as TForm2).ListBox1.Clear;
  (ChatWnd.Items[RoomIndex(Room)] as TForm2).ListBox1.Items:=
   Irc1.irc.room[Irc1.irc.Ind(Room)].UserListOV;
   //use UserList instead of UserListOV
   //if '@' and '+' (op/voice) nicks preffix/suffix not required
 end;
end;

procedure TForm1.Irc1Privmsg(Sender: TObject; ForMe: Boolean; Nick, User,
  Host, Dest, Msg: String);
var
 n:integer;
begin
 //Normal IRC message from Nick
 if ForMe then begin
  n:=UserIndex(Nick);
  if n<0 then begin
   NewUserWnd(Nick);
  end;
  (UserWnd.Items[UserIndex(Nick)] as TForm3).AddText('<'+Nick+'> '+Msg);
 end else begin
  (ChatWnd.Items[RoomIndex(Dest)] as TForm2).AddText('<'+Nick+'> '+Msg);
 end;
end;

procedure TForm1.Irc1Notice(Sender: TObject; ForMe: Boolean; Nick, User,
  Host, Dest, Msg: String);
var
 n:integer;
begin
 //Notice IRC message from Nick
if length(Nick)>0 then begin

 if ForMe then begin
  n:=UserIndex(Nick);
  if n<0 then begin
   NewUserWnd(Nick);
  end;
  (UserWnd.Items[UserIndex(Nick)] as TForm3).AddText('<'+Nick+'> NOTICE '+Msg);
 end else begin
  (ChatWnd.Items[RoomIndex(Dest)] as TForm2).AddText('<'+Nick+'> NOTICE '+Msg);
 end;

end else AddText('<'+Host+'> NOTICE '+Msg);
end;

procedure TForm1.Irc1Part(Sender: TObject; ForMe: Boolean; Room, Nick,
  PartMsg: String);
begin
 //Somebody Part <Room> channel
 if RoomIndex(Room)>-1 then begin
  if ForMe then begin
   (ChatWnd.Items[RoomIndex(Room)] as TForm2).Close;
   AddText(Nick+' PART '+Room+' :'+PartMsg);
  end else
   (ChatWnd.Items[RoomIndex(Room)] as TForm2).AddText(Nick+' PART '+Room+' :'+PartMsg);
 end else AddText(Nick+' PART '+Room+' :'+PartMsg);
end;

procedure TForm1.Irc1Quit(Sender: TObject; ForMe: Boolean; Nick,
  QuitMsg: String);
var
 i:integer;
begin
 //Somebody Quit IRC server
 if not ForMe then begin
  for i:=0 to Irc1.Irc.count-1 do begin
   if Irc1.Irc.room[i].Ind(Nick)>-1 then
   (ChatWnd.Items[RoomIndex(Irc1.Irc.room[i].name)] as TForm2).AddText(Nick+' QUIT :'+QuitMsg);
  end;
 end;
end;

procedure TForm1.Irc1Nick(Sender: TObject; ForMe: Boolean; OldNick,
  NewNick: String);
var
 i:integer;
begin
 //Somebody changed his nick
 for i:=0 to Irc1.Irc.count-1 do begin
  if Irc1.Irc.room[i].Ind(OldNick)>-1 then
  (ChatWnd.Items[RoomIndex(Irc1.Irc.room[i].name)] as TForm2).AddText(OldNick+' NOW KNOWN AS '+NewNick);
 end;
end;

procedure TForm1.Irc1Kick(Sender: TObject; ForMe: Boolean; KickerNick,
  KickedNick, Room, KickMsg: String);
begin
 //Somebody Kicks user from <Room> channel
 if not ForMe then begin
  (ChatWnd.Items[RoomIndex(Room)] as TForm2).AddText(KickerNick+' KICKED '+KickedNick+' :'+KickMsg);
 end else begin
  (ChatWnd.Items[RoomIndex(Room)] as TForm2).Close;
  AddText(KickerNick+' KICKED YOU FROM '+Room+' :'+KickMsg);
 end;
end;

procedure TForm1.Irc1Mode(Sender: TObject; ForMe: Boolean; Nick, Room,
  Mode: String);
begin
 //Somebody Changed mode for <user/channel> channel
 //Look into the <Mode> to know what happend exactly
 //Example: Mode='+o FineNickName' or Mode='+sm #MyChannel';
 (ChatWnd.Items[RoomIndex(Room)] as TForm2).AddText(Nick+' CHANGED MODE '+Mode);
end;

procedure TForm1.Irc1Ping(Sender: TObject; Nick, User, Host,
  idstr: String);
begin
 //Somebody pinging you used CTCP IRC ping
 Irc1.SendText('NOTICE '+Nick+' :'+chr(1)+'PONG '+idstr+chr(1));
end;

procedure TForm1.Irc1Time(Sender: TObject; Nick, User, Host: String);
begin
 //Somebody ask your local time
 Irc1.SendText('NOTICE '+Nick+' :'+chr(1)+'LOCALTIME IS '+DateTimeToStr(Now)+chr(1));
end;

procedure TForm1.Irc1Topic(Sender: TObject; ForMe: Boolean; Nick, Room,
  Topic: String);
begin
 //Topic message received/changed
 if Length(Nick)>0 then
  (ChatWnd.Items[RoomIndex(Room)] as TForm2).AddText(Nick+' CHANGED TOPIC '+Topic)
 else
  (ChatWnd.Items[RoomIndex(Room)] as TForm2).AddText(Room+' TOPIC IS '+Topic);
end;

procedure TForm1.Irc1Irc(Sender: TObject; Server: String);
begin
 //
 // TO DO: It is good idea to add channel automatic join code here.
 // Example: Irc1.SendText('JOIN '+MyFavouriteChannel);
 //
 Statusbar1.SimpleText:=Server+':'+Irc1.Nick;
end;

procedure TForm1.Irc1Version(Sender: TObject; Nick, User, Host: String);
begin
 //Somebody ask your version
 //If Irc1.Version='' then no version info will be sent back
 Irc1.SendText('NOTICE '+Nick+' :'+chr(1)+DemoVerMsg+chr(1));
end;

procedure TForm1.Irc1Names(Sender: TObject; Room: String);
begin
 //Here can be code:
 //What to do when received info on last 'NAMES #channel' request
end;

procedure TForm1.Irc1CTCP(Sender: TObject; Nick, User, Host, Cmd,
  Par: String);
begin
 //Here can be code:
 //What to do when CTCP request received:
 //Analysis what kind of CTCP message and so on.
end;

procedure TForm1.Irc1DCC(Sender: TObject; Nick, User, Host, Cmd,
  Par: String);
begin
 //Here can be code:
 //What to do when DCC request received:
 //Analysis what kind of CTCP message and so on.
 //if Cmd='SEND' then <Perform Receive file dialog and code.>
 //if Cmd='CHAT' then <Perform Direct chat dialog and code.>
end;

procedure TForm1.Irc1ServerError(Sender: TObject; ErrMsg: String);
begin
 AddText('SERVER ERROR :'+ErrMsg);
end;

procedure TForm1.Irc1SocketError(Sender: TObject; ErrCode: Integer);
begin
 AddText('SOCKET ERROR :'+IntToStr(ErrCode));
end;

end.
